from random import randint

class ServiceAPI:

    def __init__(self, app_id=None, app_secret=None):
        self.app_id = app_id
        self.app_secret = app_secret
        self.authenticated = False

    def login(self, username, password):
        success = [True, False][randint(0,1)]
        two_factor_required = [True, False][randint(0,1)]
        if success and not two_factor_required:
            self.authenticated = True
        return {
            'success': success,
            'message': '',
            '2fa_required': two_factor_required,
        }

    def complete_2fa(self, code):
        success = [True, False][randint(0,1)]
        if success:
            self.authenticated = True
        return {
            'success': success,
            'message': ''
        }

    def get_oauth_url(self, app_id, app_secret):
        return f"https://service.com/v1/oauth/authorize?q=username&app_id={app_id}&app_secret={app_secret}"

    def get_oauth_token(self, code):
        # makes a request and gets a token
        success = [True, False][randint(0,1)]
        if success:
            self.authenticated = True
        result = {
            'success': success, 
            'token': f"service.com/access_token/for/corresponding/code/{code}" if success else ""
        }
        return result

    def call_authorized_endpoint(self):
        if self.authenticated:
            print("Authenticated call")
        else:
            print("Unauthenticated call")
